package com.hero.objects.powers;

import java.text.NumberFormat;

import org.jdom.Element;

import com.hero.HeroDesigner;
import com.hero.objects.GenericObject;

/**
 * Copyright (c) 2000 - 2005, CompNet Design, Inc. All rights reserved.
 * Redistribution and use in source and binary forms, with or without
 * modification, is prohibited unless the following conditions are met: 1.
 * Express written consent of CompNet Design, Inc. is obtained by the developer.
 * 2. Redistributions must retain this copyright notice. THIS SOFTWARE IS
 * PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS ``AS IS'' AND ANY EXPRESS
 * OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
 * OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO
 * EVENT SHALL THE COPYRIGHT HOLDERS OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT,
 * INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES
 * (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
 * LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND
 * ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
 * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
 * SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 * 
 * @author CompNet Design, Inc.
 * @version $Revision$
 */

public class Microscopic extends SenseAdder {

	private static String xmlID = "MICROSCOPIC";

	public Microscopic(Element root) {
		super(root, Microscopic.xmlID);
		if ((options != null) && (options.size() > 0)) {
			setSelectedOption(options.get(0));
		}
	}

	@Override
	public String getColumn2Output() {
		String ret = getAlias() + " (" + getDamageDisplay() + ")";
		if (getName().trim().length() > 0) {
			ret = "<i>" + getName() + ":</i>  " + ret;
		}

		String withString = " with ";
		if (getSelectedOption() != null) {
			withString += getSelectedOption().getAlias();

			String adderString = getAdderString();
			if (adderString.trim().length() > 0) {
				withString += ", " + adderString;
				withString = withString.substring(0, withString
						.lastIndexOf(","))
						+ " and"
						+ withString.substring(withString.lastIndexOf(",") + 1,
								withString.length());
			}
		} else {
			String adderString = getAdderString();
			if (adderString.trim().length() > 0) {
				withString += " " + adderString;
				if (withString.indexOf(", ") > 0) {
					withString = withString.substring(0, withString
							.lastIndexOf(","))
							+ " and"
							+ withString.substring(
									withString.lastIndexOf(",") + 1, withString
											.length());
				}
			}
		}
		if (!withString.trim().equals("with")) {
			ret += withString;
		}
		if ((getInput() != null) && (getInput().trim().length() > 0)) {
			ret += ":  " + getInput();
		}
		ret += getModifierString();
		if ((getEndUsage() > 0)
				&& (GenericObject.findObjectByID(HeroDesigner.getActiveHero()
						.getPowers(), "ENDURANCERESERVE") != null)
				&& (GenericObject.findObjectByID(getAllAssignedModifiers(),
						"ENDRESERVEOREND") == null)
				&& !HeroDesigner.getInstance().getPrefs().useWG()) {
			if (getUseENDReserve()) {
				ret += " (uses END Reserve)";
			} else {
				ret += " (uses Personal END)";
			}
		}

		return ret;
	}

	@Override
	public String getDamageDisplay() {
		String ret = " x";
		ret += ""
				+ NumberFormat.getIntegerInstance().format(
						Math.pow(getLevelPower(), getLevels()));
		return ret;
	}
}